----------------------------------------------------------------------------
--
-- © Copyright CERN 2000-2024. All rigths reserved. This software is released under a CERN proprietary software licence.
-- Any permission to use it shall be granted in writing. Request shall be adressed to CERN through mail-KT@cern.ch
--
----------------------------------------------------------------------------

%parser Table_LGCOutputResLexer
%decl LGCOutputResLexer.hpp
%impl LGCOutputResLexer_gen.cpp

-- BASIC TOKENS
%token UNKNOWN "Unknown" -- Unrecognized token
%token EOL_SYMBOL "New line '\\n'"
%token COMMENTSTRING "Comment"
%token WORD "Word"
%token INTEGER "Integer number"
%token DECIMAL "Decimal number"
%token IND "IND"
-- Special characters
%token COLON ":"
%token EQUAL "="
%token ASTERISKS "*"

-- KEYWORDS
	%token POINT "POINT"
	%token POINTS "POINTS"
	-- Sections
		%token SUMMARY_START "CALCUL DU" 
		%token STATISTICS_START "*** STATISTIQUES ***"
		%token STATISTICS_CONTENTS_START "SIGMA ZERO A POSTERIORI"
		%token MEASURES_SUMMARY_START "*** RESUME DES MESURES ***"
		%token MEASURES_START "*** MESURES ***"
		%token EREL_START "ERREURS RELATIVES"
		%token END "*** FIN DE FICHIER ***"
	-- Options
		-- Datum Options
			%token LEP "LEP"
			%token OLOC "OLOC"
			%token RS2K "RS2K"
			%token SPHE "SPHE"
	-- Statistics
		%token VARIABLES "VARIABLES"
		%token INVARIABLES "INVARIABLES"
		%token CALAGE "CALAGE"
		%token XYZ "XYZ"
		%token X "X"
		%token Y "Y"
		%token Z "Z"
		%token ELLIPSOIDS "ABSOLUTE ERROR ELLIPSOIDS"
		%token ELLIPSES "ABSOLUTE ERROR ELLIPSES"
		%token PDOR "PDOR"
		%token SFP "SFP"
	-- Measures Summary
		-- CAMD
			-- CAM
				%token UVEC "UVEC"
				%token UVD "UVD"
		-- EDM
			%token DSPT "DSPT"
		-- LEVEL
			%token DLEV "DLEV"
		-- POLAR
			-- TSTN
				%token ANGL "ANGL"
				%token ECDIR "ECDIR"
				%token ECTH "ECTH"
				%token DHOR "DHOR"
				%token DIST "DIST"
				%token PLR3D "PLR3D"
				%token ZEND "ZEND"
			-- Other
				%token ORIE "ORIE"
		-- SCALE
			%token ECHO "ECHO"
		-- INCL
			%token INCLY "INCLY"
		-- HLSR
			%token ECWS "ECWS"
		-- WPSR
			%token ECWI "ECWI"
		-- NO TYPE
			%token DVER "DVER"
			%token OBSXYZ "OBSXYZ"
			%token RADI "RADI"
		-- HISTOGRAMS
			%token REPARTITION "REPARTITION"
	-- Measurements
		-- CAMD type
			%token CAM "CAMERA INSTRUMENT"
			-- CAM Measures
				%token CAMUVD "Vecteur directeur + Distance (UVD)"
				%token CAMUVEC "Vecteur directeur"
		-- EDM
			%token EDM "INSTRUMENT EDM"
		-- LEVEL
			%token LEVEL "LEVEL INSTRUMENT"
		-- POLAR type
			%token POLAIRE "INSTRUMENT POLAIRE"
			-- POLAR Measures
				-- TSTN
					%token TSTNANGL "ANGLES HORIZONTAUX"
					%token TSTNECDIR "ECART A UNE DIRECTION"
					%token TSTNECTH "ECART A UN PLAN VERTICAL"
					%token TSTNDHOR "DISTANCES HORIZONTALES"
					%token TSTNDIST "DISTANCES MESUREES"
					%token TSTNZEND "DISTANCES ZENITHALES"
				-- OTHER
					%token PLRORIE "CONTRAINTES D'ORIENTATION"
		-- SCALE type
			-- SCALE Measures
				%token ECSP "ECSP"
				%token ECVE "ECVE"
		-- NO TYPE
			-- NO TYPE Measures
				%token CONTRAINTES3D "CONTRAINTES 3D SUR UN POINT"
				%token RADIAL "CONTRAINTES RADIALES"
	-- FRAMES
		%token FRAME "FRAME"
		%token FRAME_PARAMETER "PARAMETER"
		-- FRAMES ROTATIONS AND TRANSLATIONS
			% token XY "XY"
			% token XZ "XZ"
			% token YZ "YZ"
		
-- STARTING POINT
%start LGCRes

-- LGCOutputResLexer.hpp

/:
/**
 * /!\ This file is automatically generated by QLALR from LGCOutputResLexer.g.
 * /!\ Don't edit it!
 */

#ifndef LGCOUTPUTRESLEXER_HPP
#define LGCOUTPUTRESLEXER_HPP

#include <unordered_set>

#include <ShareablePoints/ShareablePointsList.hpp>
#include <editors/text/LexerParser.hpp>

#include "LGCMeasures.hpp"

#include "$header"

class LGCPlugin;

class LGCOutputResLexer : public LexerParser<$table>
{
	Q_OBJECT

public:
	LGCOutputResLexer(QObject *parent = nullptr);
	virtual ~LGCOutputResLexer() override = default;

	// QsciLexerCustom
	enum Styles
	{
		/** Default */
		Default,
		/** Comment / ignored part */
		Comment,
		/** not special stuff */
		Normal,
		// values
		ValueImportant,
		ValueCorrect,
		ValueWarning,
		ValueError,
		// keywords
		Section,
		/** Option keywords */
		DatumOption,
		OptionParameter,
		/** Intruments */
		InstrumentType,
		InstrumentName,
		TargetName,
		/** Points */
		PointType,
		PointName,
		PointCoord,
		PointSigma,
		/** Frames */
		Frame,
		FrameName,
		/** Measures (same as Options) */
		MeasureType,
		MeasureParameter = OptionParameter
	};
	// implemented in LGCOutputResLexer_impl.cpp
	virtual const char *language() const override { return "LGCPointRes"; }
	virtual const char *keywords(int set) const override;
	virtual QString description(int style) const override;
	virtual const char *wordCharacters() const override;
	virtual bool defaultEolFill(int style) const override;
	QColor defaultColor(int style) const override;
	QFont defaultFont(int style) const override;
	QColor defaultPaper(int style) const override;

	// IShareablePointsListIO
	// implemented in LGCOutputResLexer_impl.cpp
	virtual const std::string &getMIMEType() const override;
	virtual ShareablePointsList read(const std::string &contents) override;
	virtual ShareableExtraInfos readExtraInfos(const std::string &contents) override;
	virtual ShareableFrame readFrame(const std::string &contents) override;
	virtual ShareableParams readParams(const std::string &contents) override;
	virtual ShareablePoint readPoint(const std::string &contents) override;
	virtual ShareablePosition readPosition(const std::string &contents) override;
	virtual std::string write(const ShareablePointsList &) override { return std::string(); }
	virtual std::string write(const ShareableExtraInfos &) override { return std::string(); }
	virtual std::string write(const ShareableFrame &) override { return std::string(); }
	virtual std::string write(const ShareableParams &) override { return std::string(); }
	virtual std::string write(const ShareablePoint &) override { return std::string(); }
	virtual std::string write(const ShareablePosition &) override { return std::string(); }

	// LGCOutputResLexer
	/**
	 * Uses the input measures to create links between input and output file.
	 *
	 * @warning This method must be called before opening the output file.
	 */
	void lgcMeasures(LGCMeasures measures) noexcept { _inputData = std::move(measures); }
	const LGCMeasures &lgcMeasures() const noexcept { return _inputData; }
	
	bool isOloc() const noexcept { return _isOloc; }
	void isOloc(bool oloc) noexcept { _isOloc = oloc; }

protected:
	// TextLexer
	virtual int indicatorJumpTo(int indicatorType, int position, const QString &indicatorText) override;
	virtual QString calltip(int position, int indicatorType, const QString &indicator) const override;
	// LexerParser
	virtual void initLexer() override;
	virtual void endLexer() override;

private:
	// LexerParser
	// generated in in LGCInputLexerIO_gen.cpp
	int nextToken(QStringRef value) override;
	void consumeRule(int ruleno) override;

	// used in lexer
	void checkNumberInRange(int symidx, double min, double max, TextMarker marker, Styles styleOK = Styles::Normal, Styles styleError = Styles::ValueError, const QString &additionalMessage = "");
	QString findSummaryMeasureKey(const QString &instrType, const QString &pointName);
	QString setMeasure(const QString &type, const QString &measureName);
	void setFrame(QStringRef sym);
	void setFrameOrPointInSummary();

private:
	/** Inline contexts */
	enum InlineCxt
	{
		STATISTICS_POINT
	};
	/** Contexts */
	enum Context
	{
		HEADER,
		SUMMARY,
		STATISTICS_HEADER,
		STATISTICS_CONTENTS,
		STATISTICS_POINT_CALA,
		STATISTICS_POINT_XYZ,
		STATISTICS_POINT_XY,
		STATISTICS_POINT_XZ,
		STATISTICS_POINT_YZ,
		STATISTICS_POINT_Z,
		STATISTICS_POINT_PDOR,
		MEASURES_SUMMARY,
		MEASURES
	};
	// Context handling ensuring changing the context or adding new if there is none
	void contextChange(Context val);

private:
	/** Current frame during parsing */
	ShareableFrame *_curFrame = nullptr;
	/** input measures */
	LGCMeasures _inputData;
	/** output measures */
	LGCMeasures _resData;
	/** mapping line indexes to summary measures; only used along with _resData.instruments to map summaries to the MEASURE blocks properly */
	std::unordered_map<int, QString> _summarylineToMeasure;
	/** set containing all measures in summary; used to keep track of previously defined measures; only used with _summarylineToMeasure to map sections properly */
	std::unordered_set<QString> _summaryMeasures;
	/** Reference system */
	bool _isOloc = true;
	/** temporary counter */
	size_t _tmpcounter = 0;
	/** current instrument or frame name */
	QString _curTmp;
	/** current header point name */
	QString _curHeaderPoint;
	/** Point sigma threshold */
	double _threshPSigma = 5;
	/** Point coordinate threshold */
	double _threshPDisplacement = 5;
	/** Measure RES/SIG threshold */
	double _threshMSigma = 5;
	/** Temporary ints used for frame folding based on ID */
	int _curTmpFrameLevel;
	int _curTmpFrameLevelNext;
	/** Required for measurement data point and frame identification */
	char _pointOrFrameFlags = 0x00;
};

#endif // LGCOUTPUTRESLEXER_HPP
:/

-- LGCOutputResLexer_gen.cpp

/.
/**
 * /!\ This file is automatically generated by QLALR from LGCOutputResLexer.g.
 * /!\ Don't edit it!
 */

#include <algorithm>

#include <QRegularExpression>

#include <Qsci/qsciscintilla.h>

#include <ShareablePoints/SPIOException.hpp>
#include <ShareablePoints/ShareableExtraInfos.hpp>
#include <ShareablePoints/ShareableFrame.hpp>
#include <ShareablePoints/ShareableParams.hpp>
#include <ShareablePoints/ShareablePoint.hpp>
#include <ShareablePoints/ShareablePosition.hpp>

#include "tabs/outputs/LGCOutputResLexer.hpp"

#define ADDSTYLE(rule, style) ADDSTYLEIDX((rule), style, 1)
#define ADDSTYLEIDX(rule, style, symidx) \
	case (rule): \
		addStyleSym(Styles::style, (symidx)); \
		break

#define FLAG_NO_FLAG			0x00
#define FLAG_IS_POINT			0x01
#define FLAG_IS_FRAME			0x02
#define FLAG_PRIORITIZE_POINT 	0x04
#define FLAG_PRIORITIZE_FRAME 	0x08

namespace
{
inline QString toTrimmedQString(const QStringRef &str)
{
	return str.trimmed().toString();
}
} // namespace

void LGCOutputResLexer::checkNumberInRange(int symidx, double min, double max, TextMarker marker, Styles styleOK, Styles styleError, const QString& additionalMessage)
{
	static const QString statusstring = tr(R"""(<h1 style="color: %1;">%2</h1>
		<p style="color: %1;">Value %3 is %4.</p>)""");

	if (!_lexerMode)
		return;

	bool ok = false;
	const double value = sym(symidx).toDouble(&ok);
	if (ok && (min > max || (value >= min && value <= max)))
	{
		addStyleSym(styleOK, symidx);
		return;
	}

	addStyleSym(styleError, symidx);
	QString color, header;
	if(marker == TextMarker::ERROR || marker == TextMarker::WARNING)
	{
		color = "red";
		header = "Error";
	}
	else
	{
		color = "blue";
		header = "Info";
	}

	if (min == max)
		_infoAnnotation += statusstring.arg(color).arg(header).arg(sym(symidx).toString()).arg(tr("not %1").arg(QString::number(min))) += additionalMessage;
	else
		_errorAnnotation += statusstring.arg(color).arg(header).arg(sym(symidx).toString()).arg(tr("out of range [%2; %3]").arg(QString::number(min), QString::number(max))) += additionalMessage;
	// add marker if none with higher priority was set before
	const int pos = sym(symidx).position();
	int line, index;
	editor()->lineIndexFromPosition(pos, &line, &index);
	const std::bitset<32> markers = editor()->markersAtLine(line);
	if (marker == TextMarker::ERROR
		|| (marker == TextMarker::WARNING && !markers[TextMarker::ERROR])
		|| (!markers[TextMarker::ERROR] && !markers[TextMarker::WARNING]))
		addMarker(editor(), pos, marker);
}

QString LGCOutputResLexer::findSummaryMeasureKey(const QString &instrType, const QString &pointName)
{
	QString msrid = instrType + '/' + pointName;
	int i = 0;
	while (_summaryMeasures.find(msrid + '/' + QString::number(i)) != std::cend(_summaryMeasures))
		i++;
	_summaryMeasures.insert(msrid + '/' + QString::number(i));
	return msrid + '/' + QString::number(i);
}

QString LGCOutputResLexer::setMeasure(const QString &type, const QString &measureName)
{
	if (!_lexerMode)
		return "";
	QString msrid = _curTmp + '/' + type + '/' + measureName;
	int i = 0;
	while (contains(_resData.measures, msrid + '/' + QString::number(i)))
		i++;
	_resData.measures.emplace(msrid + '/' + QString::number(i), LGCMeasures::Value{sym(1).position(), msrid + '/' + QString::number(i), measureName, _currentLine.toString(), type, _curTmp, _unusedComment});

	if (type == "OBSXYZ")
		i /= 3;
	return msrid + '/' + QString::number(i);
}

void LGCOutputResLexer::setFrame(QStringRef sym)
{
	QString name = toTrimmedQString(sym);
	if (contains(_inputData.frames, name))
		addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::frames));
}

void LGCOutputResLexer::setFrameOrPointInSummary()
{
	QString name = toTrimmedQString(sym(1));
	if (contains(_inputData.points, name))
		_pointOrFrameFlags = _pointOrFrameFlags | FLAG_IS_POINT;
	if (contains(_inputData.frames, name) || name == "ROOT") // since "ROOT" is the only possible "virtual" frame I don't create an extra case for it
		_pointOrFrameFlags = _pointOrFrameFlags | FLAG_IS_FRAME;
	switch(_pointOrFrameFlags)
	{
		case FLAG_IS_POINT | FLAG_PRIORITIZE_FRAME:
			[[fallthrough]];
		case FLAG_IS_POINT | FLAG_PRIORITIZE_POINT:
			// if only a point is found
			addStyleSym(Styles::PointName, 1);
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::points));
			break;
		case FLAG_IS_FRAME | FLAG_PRIORITIZE_FRAME:
			[[fallthrough]];
		case FLAG_IS_FRAME | FLAG_PRIORITIZE_POINT:
			// if only frame is found
			addStyleSym(Styles::FrameName, 1);
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::frames));
			break;
		case FLAG_IS_POINT | FLAG_IS_FRAME | FLAG_PRIORITIZE_POINT:
			addStyleSym(Styles::PointName, 1);
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::points));
			break;
		case FLAG_IS_POINT | FLAG_IS_FRAME | FLAG_PRIORITIZE_FRAME:
			addStyleSym(Styles::FrameName, 1);
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::frames));
			break;
		default:
			// if no case is hit I assume it is a virtual point created by LGC and colour it as a point without linkage
			addStyleSym(Styles::PointName, 1);
			break;
	}
}

void LGCOutputResLexer::contextChange(Context val)
{
	if (_contexts.empty())
		_contexts.push_back(val);
	else
		_contexts.back() = val;
}

void LGCOutputResLexer::consumeRule(int rule)
{
	switch(rule)
	{
./

----------------------------------------------------------- RULES

---- Definitions

EOL: EOL_SYMBOL
	| EOL EOL_SYMBOL;

Number: INTEGER
	| DECIMAL
	| IND;

AlNum: WORD
	| UNKNOWN
	| Number;

POINTNAMEDEF: WORD
/. case $rule_number: ./
	| INTEGER;
/.
	case $rule_number:
	{
		addStyleSym(Styles::PointName, 1);
		QString name = toTrimmedQString(sym(1));
		if (contains(_inputData.points, name))
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::points));
		break;
	}
./
FRAMENAME: WORD;
/.
	case $rule_number:
		addStyleSym(Styles::FrameName, 1);
		setFrame(sym(1));
		break;
./
FRAMETOKEN: FRAME;
/.
	case $rule_number:
		addStyleSym(Styles::Frame, 1);
		break;
./
FrameTransformationToken: XY
/. case $rule_number: ./
	| XZ
/. case $rule_number: ./
	| YZ;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::Normal);
		break;
./
INSTRNAMEDEF: WORD;
/.
	case $rule_number:
	{
		addStyleSym(Styles::InstrumentName, 1);
		_curTmp = toTrimmedQString(sym(1));
		if (contains(_inputData.instruments, _curTmp))
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(_curTmp, LGCMeasures::LGCMeasuresEnum::instruments));
		break;
	}
./
INSTRNAME: WORD;
/.
	case $rule_number:
	{
		// Does not set a new instrument, meant to add styling and create a link
		addStyleSym(Styles::InstrumentName, 1);
		if (contains(_inputData.instruments, toTrimmedQString(sym(1))))
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(toTrimmedQString(sym(1)), LGCMeasures::LGCMeasuresEnum::instruments));
		break;
	}
./
TGTNAMEDEF: WORD;
/.
	case $rule_number: //TGTNAMEDEF
	{
		addStyleSym(Styles::TargetName, 1);
		QString name = _curTmp + '/' + toTrimmedQString(sym(1));
		if (contains(_inputData.targets, name))
			addIndicationSym(TextIndicator::EXTERNAL, 1, LGCMeasures::encodeIndicator(name, LGCMeasures::LGCMeasuresEnum::targets));
		break;
	}
./

---- Global

LGCRes: Header Summary Statistics MeasuresSummary MeasurementsStart Contents End;

------ Contents

Contents: Content
	| Content Contents;
Content: Measurements
	| Erel
	| Frames
	| ErelFrame;
---- Header

Header: HeaderDef;
/.
	case $rule_number: // HEADER
		endFolding();
		break;
./
HeaderDef: HeaderBegin HeaderRubbish EOL
	| HeaderDef HeaderRubbish EOL;
HeaderBegin: EOL_SYMBOL EOL_SYMBOL;
/.
	case $rule_number:
		startFolding();
		break;
./
HeaderRubbish: ASTERISKS
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./
	| COLON
/. case $rule_number: ./
	| EQUAL
/. case $rule_number: ./
	| POINT
/. case $rule_number: ./
	| POINTS
/. case $rule_number: ./
	| AlNum
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
	| HeaderRubbish ASTERISKS
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 2);
		break;
./
	| HeaderRubbish COLON
/. case $rule_number: ./
	| HeaderRubbish EQUAL
/. case $rule_number: ./
	| HeaderRubbish AlNum;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		break;
./

---- Summary

Summary: SummaryDef;
/.
	case $rule_number: // SUMMARY
		endFolding();
		break;
./
SummaryDef: SummaryStart SummaryValues;
SummaryStart: SummaryStartToken SummaryStartRubbish EOL_SYMBOL SummaryLine EOL;
SummaryStartToken: SUMMARY_START;
/.
	case $rule_number:
		addStyleSym(Styles::Section, 1);
		contextChange(Context::SUMMARY);
		startFolding();
		break;
./
SummaryStartRubbish: AlNum
/. case $rule_number: ./
	| COLON
/.
	case $rule_number:
		addStyleSym(Styles::Section, 1);
		break;
./
	| SummaryStartRubbish AlNum
/. case $rule_number: ./
	| SummaryStartRubbish COLON;
/.
	case $rule_number:
		addStyleSym(Styles::Section, 2);
		break;
./
SummaryLine: ASTERISKS;
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./
SummaryValues: SummaryValuesDef EOL
	| SummaryValues SummaryValuesDef EOL;
SummaryValuesDef: SummaryValuesRubbish COLON
	| SummaryValuesRubbish COLON SummaryValue;
SummaryValuesRubbish: WORD
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
	| SummaryValuesRubbish WORD;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		break;
./
SummaryValue: INTEGER;
/.
	case $rule_number:
		addStyleSym(Styles::ValueImportant, 1);
		break;
./

---- Statistics

StatisticsRubbish: AlNum
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
	| StatisticsRubbish AlNum;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		break;
./

Statistics: StatisticsStart StatisticsContent;
/.
	case $rule_number:
		endFolding();
		break;
./
StatisticsStart: StatisticsStartToken EOL;
StatisticsStartToken: STATISTICS_START WORD ASTERISKS;
/.
	case $rule_number: // STATISTICS
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		contextChange(Context::STATISTICS_HEADER);
		startFolding();
		break;
./
StatisticsContent: StatisticsSummary FrameDescription StatisticsPoints
	| StatisticsSummary FrameDescription StatisticsPoints StatisticsPointPdor;
StatisticsSummary: StatisticsNumbers StatisticsSigma EOL StatisticsRubbish EOL
	| StatisticsNumbers StatisticsFree StatisticsSigma  EOL StatisticsRubbish EOL;
StatisticsNumbers: StatisticsNumber EOL StatisticsNumber EOL StatisticsNumber EOL StatisticsNumber EOL;
StatisticsNumber: StatisticsRubbish EQUAL INTEGER
/. case $rule_number: ./
	| StatisticsRubbish EQUAL INTEGER StatisticsRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::ValueImportant, 3);
		break;
./
StatisticsSigma: StatisticsContentsToken StatisticsRubbish EQUAL StatisticsSigmaDef;
StatisticsContentsToken: STATISTICS_CONTENTS_START;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		contextChange(Context::STATISTICS_CONTENTS);
		break;
./
StatisticsSigmaDef: DECIMAL WORD WORD WORD EQUAL WORD WORD WORD
/.
	case $rule_number:
	{
		const double sigmamin = sym(6).mid(1).toDouble(); // All after (
		const double sigmamax = sym(8).split(')')[0].toDouble(); // All before )
		
		checkNumberInRange(1, sigmamin, sigmamax, TextMarker::ERROR, Styles::ValueCorrect);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::ValueImportant, 6);
		addStyleSym(Styles::Normal, 7);
		addStyleSym(Styles::ValueImportant, 8);
		break;
	}
./
	| DECIMAL WORD WORD WORD EQUAL WORD DECIMAL WORD WORD; -- TO DO: to be deleted when space between paranthesis is removed
/.
	case $rule_number:
	{
		const double sigmamin = sym(7).toDouble();
		const double sigmamax = sym(9).split(')')[0].toDouble(); // All before )
		
		checkNumberInRange(1, sigmamin, sigmamax, TextMarker::ERROR, Styles::ValueCorrect);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::ValueImportant, 7);
		addStyleSym(Styles::Normal, 8);
		addStyleSym(Styles::ValueImportant, 9);
		break;
	}
./
StatisticsFree: StatisticsFreeRubbish EOL
	| StatisticsFree StatisticsFreeRubbish EOL;
StatisticsFreeRubbish: ASTERISKS
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./
	| COLON
/. case $rule_number: ./
	| AlNum
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
	| StatisticsFreeRubbish ASTERISKS
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 2);
		break;
./
	| StatisticsFreeRubbish COLON
/. case $rule_number: ./
	| StatisticsFreeRubbish AlNum;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		break;
./

	-- Points
StatisticsPointsToken: POINTS;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		_inlineContexts.insert(InlineCxt::STATISTICS_POINT);
		startFolding();
		break;
./
StatisticsPointsRef: WORD EQUAL INTEGER WORD WORD EQUAL StatisticsPointsRefToken WORD;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::Normal, 8);
		break;
./
StatisticsPointsRefToken: OLOC
/.
	case $rule_number:
		_isOloc = true;
		addStyleSym(Styles::DatumOption, 1);
		if (!_lexerMode && _curFrame)
			_curFrame->getParams().extraInfos["coordinateSystem"] = std::string("*") + toByteArray(toTrimmedQString(sym(1)), utf8()).constData();
		break;
./
	| LEP
/. case $rule_number: ./
	| RS2K
/. case $rule_number: ./
	| SPHE;
/.
	case $rule_number:
		_isOloc = false;
		addStyleSym(Styles::DatumOption, 1);
		if (!_lexerMode && _curFrame)
			_curFrame->getParams().extraInfos["coordinateSystem"] = std::string("*") + toByteArray(toTrimmedQString(sym(1)), utf8()).constData();
		break;
./
StatisticsPointsDef: StatisticsPointDef EOL
	| StatisticsPointsDef StatisticsPointDef EOL;
StatisticsPointDef: POINTNAMEDEF StatisticsPointDefCoordinates
/.
	case $rule_number:
		_tmpcounter = 0;
		if (!_lexerMode && _curFrame)
			_curFrame->getPoint(_curFrame->sizePoints() - 1).name = toByteArray(toTrimmedQString(sym(1)), utf8()).constData();
		break;
./
	| ASTERISKS POINTNAMEDEF StatisticsPointDefCoordinates;
/.
	case $rule_number:
		addStyleSym(Styles::PointName, 1);
		_tmpcounter = 0;
		break;
./
StatisticsPointDefCoordinates: StatisticsPointDefCoordinate
	| StatisticsPointDefCoordinates StatisticsPointDefCoordinate;
StatisticsPointDefCoordinate: Number;
/.
	case $rule_number:
	{
		if (_contexts.empty())
			break;
		ShareablePoint *point = nullptr;
		size_t coordSize = _isOloc ? 3 : 4;
		size_t sigmaSize = 0;

		if (!_lexerMode && _tmpcounter == 0)
			point = &_curFrame->addPoint();
		else if (!_lexerMode)
			point = &_curFrame->getPoint(_curFrame->sizePoints() - 1);
			
		if (!_contexts.empty())
		{
			switch (_contexts.back())
			{
			case Context::STATISTICS_POINT_CALA:
				sigmaSize = 0;
				if (!_lexerMode)
				{
					point->position.isfreex = false;
					point->position.isfreey = false;
					point->position.isfreez = false;
				}
				break;
			case Context::STATISTICS_POINT_Z:
				sigmaSize = 1;
				if (!_lexerMode)
				{
					point->position.isfreex = false;
					point->position.isfreey = false;
					point->position.isfreez = true;
				}
				break;
			case Context::STATISTICS_POINT_XYZ:
				sigmaSize = 3;
				if (!_lexerMode)
				{
					point->position.isfreex = true;
					point->position.isfreey = true;
					point->position.isfreez = true;
				}
				break;
			case Context::STATISTICS_POINT_XY:
				sigmaSize = 2;
				if (!_lexerMode)
				{
					point->position.isfreex = true;
					point->position.isfreey = true;
					point->position.isfreez = false;
				}
				break;
			case Context::STATISTICS_POINT_XZ:
				sigmaSize = 2;
				if (!_lexerMode)
				{
					point->position.isfreex = true;
					point->position.isfreey = false;
					point->position.isfreez = true;
				}
				break;
			case Context::STATISTICS_POINT_YZ:
				sigmaSize = 2;
				if (!_lexerMode)
				{
					point->position.isfreex = false;
					point->position.isfreey = true;
					point->position.isfreez = true;
				}
				break;
			}
		}

		if (_tmpcounter < coordSize)
		{
			addStyleSym(Styles::PointCoord, 1);
			if (!_lexerMode && _tmpcounter == 0)
				point->position.x = sym(1).toDouble();
			else if (!_lexerMode && _tmpcounter == 1)
				point->position.y = sym(1).toDouble();
			else if (!_lexerMode)
				point->position.z = sym(1).toDouble();
		}
		else if (_tmpcounter >= coordSize + sigmaSize)
			checkNumberInRange(1, -_threshPDisplacement, _threshPDisplacement, TextMarker::WARNING);
		else
		{
			checkNumberInRange(1, -_threshPSigma, _threshPSigma, TextMarker::WARNING, Styles::PointSigma);
			
			if (_contexts.empty());  // Do nothing if contexts are empty
			else if (!_lexerMode && _tmpcounter == coordSize)
			{
				if (_contexts.back() == Context::STATISTICS_POINT_XYZ || _contexts.back() == Context::STATISTICS_POINT_XY || _contexts.back() == Context::STATISTICS_POINT_XZ)
					point->position.sigmax = sym(1).toDouble();
				else if (_contexts.back() == Context::STATISTICS_POINT_YZ)
					point->position.sigmay = sym(1).toDouble();
				else if (_contexts.back() == Context::STATISTICS_POINT_Z)
					point->position.sigmaz = sym(1).toDouble();
			}
			else if (!_lexerMode && _tmpcounter == coordSize + 1)
			{
				if (_contexts.back() == Context::STATISTICS_POINT_XYZ || _contexts.back() == Context::STATISTICS_POINT_XY)
					point->position.sigmay = sym(1).toDouble();
				else if (_contexts.back() == Context::STATISTICS_POINT_XZ || _contexts.back() == Context::STATISTICS_POINT_YZ)
					point->position.sigmaz = sym(1).toDouble();
			}
			else if (!_lexerMode)
				point->position.sigmaz = sym(1).toDouble();
		}
		_tmpcounter++;
		break;
	}
./
StatisticsPoints: StatisticsPointsLists StatisticsEnding;
StatisticsPointsLists: StatisticsPointsList
	| StatisticsPointsEllipses
	| StatisticsPointsLists StatisticsPointsList
	| StatisticsPointsLists StatisticsPointsEllipses;
StatisticsPointsList: StatisticsPointType StatisticsPointsRef EOL StatisticsSFPToken StatisticsRubbish EOL StatisticsRubbish EOL StatisticsPointsDef;
/.
	case $rule_number:
		if (!_contexts.empty())
			_contexts.pop_back();
		endFolding();
		break;
./
StatisticsPointType: StatisticsPointTypeCala
	| StatisticsPointTypeXYZ
	| StatisticsPointTypeXY
	| StatisticsPointTypeXZ
	| StatisticsPointTypeYZ
	| StatisticsPointTypeZ;
StatisticsPointTypeCala: StatisticsPointsToken WORD CALAGE;
/.
	case $rule_number:
		_contexts.push_back(Context::STATISTICS_POINT_CALA);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::PointType, 3);
		break;
./
StatisticsPointTypeXYZ: StatisticsPointsToken VARIABLES WORD XYZ;
/.
	case $rule_number:
		_contexts.push_back(Context::STATISTICS_POINT_XYZ);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		break;
./
StatisticsPointTypeXY: StatisticsPointsToken INVARIABLES WORD Z;
/.
	case $rule_number:
		_contexts.push_back(Context::STATISTICS_POINT_XY);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		break;
./
StatisticsPointTypeXZ: StatisticsPointsToken INVARIABLES WORD Y;
/.
	case $rule_number:
		_contexts.push_back(Context::STATISTICS_POINT_XZ);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		break;
./
StatisticsPointTypeYZ: StatisticsPointsToken INVARIABLES WORD X;
/.
	case $rule_number:
		_contexts.push_back(Context::STATISTICS_POINT_YZ);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		break;
./
StatisticsPointTypeZ: StatisticsPointsToken VARIABLES WORD  Z WORD;
/.
	case $rule_number:
		_contexts.push_back(Context::STATISTICS_POINT_Z);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::PointType, 4);
		addStyleSym(Styles::Normal, 5);
		break;
./

StatisticsSFPToken: SFP;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
StatisticsPointsEllipses: StatisticsPointsEllipsesHeader StatisticsPointsEllipsesDef;
/.
	case $rule_number:
		endFolding();
		break;
./
StatisticsPointsEllipsesHeader: StatisticsPointsEllipsesHeaderToken EOL StatisticsRubbish EOL StatisticsRubbish EOL;
StatisticsPointsEllipsesHeaderToken: ELLIPSOIDS WORD WORD
/. case $rule_number: ./
	| ELLIPSES WORD WORD;
/.
	case $rule_number:
		addStyleSym(Styles::PointType, 1);
		addStyleSym(Styles::PointType, 2);
		addStyleSym(Styles::PointType, 3);
		startFolding();
		break;
./
StatisticsPointsEllipsesDef: StatisticsPointsEllipseDef EOL
	| StatisticsPointsEllipsesDef StatisticsPointsEllipseDef EOL;
StatisticsPointsEllipseDef: POINTNAMEDEF StatisticsRubbish FRAMENAME;
StatisticsEnding: SFP StatisticsEndingRubbish EOL;
StatisticsEndingRubbish: AlNum
	| EQUAL
	| COLON
	| ASTERISKS
	| StatisticsEndingRubbish AlNum
	| StatisticsEndingRubbish EQUAL
	| StatisticsEndingRubbish COLON
	| StatisticsEndingRubbish ASTERISKS;

StatisticsPointPdor: StatisticsPointPdorStart StatisticsPointPdorValue;
/.
	case $rule_number:
		endFolding();
		break;
./
StatisticsPointPdorStart: StatisticsPointPdorStartDef EOL;
StatisticsPointPdorStartDef: StatisticsPointPdorStartDefToken WORD WORD WORD WORD WORD EQUAL INTEGER WORD;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::PointType, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::Normal, 7);
		addStyleSym(Styles::Normal, 8);
		addStyleSym(Styles::Normal, 9);
		break;
./
StatisticsPointPdorStartDefToken: POINT;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		_inlineContexts.insert(InlineCxt::STATISTICS_POINT);
		startFolding();
		break;
./
StatisticsPointPdorValue: StatisticsPointPdorValueCalaPoint StatisticsPointPdorValuePoint StatisticsRubbish EOL;
StatisticsPointPdorValueCalaPoint: WORD WORD POINTNAMEDEF;
/.
	case $rule_number:
		addStyleSym(Styles::PointType, 1);
		addStyleSym(Styles::Normal, 2);
		break;
./
StatisticsPointPdorValuePoint: WORD POINTNAMEDEF;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./

---- MeasuresSummary

MeasuresSummary: MeasuresSummaryStart MeasuresSummaryValues
/. case $rule_number: ./
	| MeasuresSummaryStart MeasuresSummaryValues MeasuresSummaryHistograms;
/.
	case $rule_number:
		endFolding();
		_summaryMeasures.clear();
		break;
./
MeasuresSummaryStart: MeasuresSummaryStartToken EOL;
MeasuresSummaryStartToken: MEASURES_SUMMARY_START WORD WORD WORD ASTERISKS;
/.
	case $rule_number: // MEASURES SUMMARY
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		addStyleSym(Styles::Section, 4);
		addStyleSym(Styles::Section, 5);
		contextChange(Context::MEASURES_SUMMARY);
		startFolding();
		break;
./

MeasuresSummaryValues: MeasuresSummaryValue
	| MeasuresSummaryValues MeasuresSummaryValue;
MeasuresSummaryValue: MeasuresSummaryValueType EOL StatisticsRubbish EOL StatisticsRubbish EOL MeasuresSummaryValueDefs MeasuresSummaryValueEnding;
/.
	case $rule_number:
		endFolding();
		_curTmp.clear();
		_summaryMeasures.clear();
		break;
./
MeasuresSummaryValueType: MeasuresSummaryValueTypePrioPoint
	| MeasuresSummaryValueTypePrioFrame
	| MeasuresSummaryValueTypePureVirtual;
MeasuresSummaryValueTypePrioPoint: ANGL
/. case $rule_number: ./
	| DHOR
/. case $rule_number: ./
	| DIST
/. case $rule_number: ./
	| DLEV
/. case $rule_number: ./
	| DSPT
/. case $rule_number: ./
	| ECDIR
/. case $rule_number: ./
	| ECTH
/. case $rule_number: ./
	| ORIE
/. case $rule_number: ./
	| UVEC COLON WORD
/. case $rule_number: ./
	| UVD COLON WORD
/. case $rule_number: ./
	| ZEND
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		[[fallthrough]];
./
	| MeasuresPlr3d;
/.
	case $rule_number:
		_pointOrFrameFlags = FLAG_PRIORITIZE_POINT;
		startFolding();
		_curTmp = toTrimmedQString(sym(1));
		break;
./

MeasuresSummaryValueTypePrioFrame: INCLY
/. case $rule_number: ./
	| DVER
/. case $rule_number: ./
	| RADI
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
./
	| MeasuresObsxyz;
/.
	case $rule_number:
		_pointOrFrameFlags = FLAG_PRIORITIZE_FRAME;
		startFolding();
		_curTmp = toTrimmedQString(sym(1));
		break;
./

MeasuresSummaryValueTypePureVirtual: ECHO
/. case $rule_number: ./
	| ECVE
/. case $rule_number: ./
	| ECSP
/. case $rule_number: ./
	| ECWS
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
./
	| MeasuresEcwi;
/.
	case $rule_number:
		_pointOrFrameFlags = FLAG_PRIORITIZE_POINT;
		startFolding();
		_curTmp = toTrimmedQString(sym(1));
		break;
./

MeasuresEcwi: ECWI COLON WORD;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		break;
./
MeasuresObsxyz: OBSXYZ COLON WORD;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		break;
./
MeasuresPlr3d: PLR3D COLON WORD;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		break;
./
MeasuresSummaryValueDefs: MeasuresSummaryValueDef EOL
	| MeasuresSummaryValueDefs MeasuresSummaryValueDef EOL;
-- It is not possible here to make the distinction between FRAMENAME and POINTNAMEDEF which is why this rule is used
-- and then the distinction is made in the cpp part.
MeasuresSummaryValueDef: WORD Number Number Number Number
/. case $rule_number: ./
	| INTEGER Number Number Number Number;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);

		setFrameOrPointInSummary();

		if (_lexerMode)
		{
			int line, index;
			editor()->lineIndexFromPosition(sym(1).position(), &line, &index);
			// knowing previous summary measures, get the next unique msrid that identifies section in MEASURES
			// even if the same measure was already defined before
			QString msrid = findSummaryMeasureKey(_curTmp, _curTmp == "ORIE" ? "" : toTrimmedQString(sym(1)));
			_summarylineToMeasure[line] = msrid;
			addIndicationSym(TextIndicator::INTERNAL, 2);
			addIndicationSym(TextIndicator::INTERNAL, 3);
			addIndicationSym(TextIndicator::INTERNAL, 4);
			addIndicationSym(TextIndicator::INTERNAL, 5);
		}
		break;
./
MeasuresSummaryValueEnding: MeasuresSummaryValueEndingDef EOL MeasuresSummaryValueEndingDef EOL;
MeasuresSummaryValueEndingDef: WORD EQUAL Number WORD COLON StatisticsRubbish EQUAL StatisticsRubbish
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::ValueImportant, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 7);
		break;
./
	| WORD WORD EQUAL Number WORD COLON StatisticsRubbish EQUAL StatisticsRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::ValueImportant, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::Normal, 8);
		break;
./

MeasuresSummaryHistograms: MeasuresSummaryHistogram
	| MeasuresSummaryHistograms MeasuresSummaryHistogram;
MeasuresSummaryHistogram: MeasuresSummaryHistogramStart MeasuresSummaryHistogramValues;
/.
	case $rule_number:
		endFolding();
		break;
./
MeasuresSummaryHistogramStart: MeasuresSummaryHistogramStartToken MeasurementsRubbish EOL;
MeasuresSummaryHistogramStartToken: REPARTITION;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		startFolding();
		break;
./
MeasuresSummaryHistogramValues: HistogramValuesStart EOL_SYMBOL HistogramValues EOL_SYMBOL HistogramValuesEnd EOL
	| HistogramValuesEnd EOL; -- Empty histogram
HistogramValuesStart: Number;
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./
HistogramValues: HistogramValue
	| HistogramValues HistogramValue;
HistogramValue: HistogramValueBar EOL_SYMBOL HistogramValueNumber EOL_SYMBOL;
HistogramValueNumber: Number;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
HistogramValueBar: ASTERISKS
/. case $rule_number: ./
	| AlNum
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./
	| HistogramValueBar ASTERISKS
/. case $rule_number: ./
	| HistogramValueBar AlNum;
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 2);
		break;
./
HistogramValuesEnd: WORD WORD WORD WORD INTEGER;
/.
	case $rule_number:
	{
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		checkNumberInRange(5, 0, 0, TextMarker::ERROR);
		break;
	}
./

---- Measurements

------ Helpers
MsrValuesRemainingNumbers: MsrValuesRemainingNumber
/. case $rule_number: ./
	| MsrValuesRemainingNumber MsrValuesRemainingNumbers;
MsrValuesRemainingNumber: Number;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
MsrValuesRemainingSigma: Number;
/.
	case $rule_number:
		checkNumberInRange(1, -_threshMSigma, _threshMSigma, TextMarker::WARNING);
		break;
./
MsrValuesRemainingConstSConst: Number Number
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		break;
./
	| Number WORD;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::ValueImportant, 2);
		break;
./
MsrValuesRemainingHtrgt: Number;
/.
	case $rule_number:
		checkNumberInRange(1, 0, 0, TextMarker::INFO, Styles::Normal, Styles::ValueImportant);

		if (!_lexerMode)
			return;
		break;
./
MSRIDTEXT: WORD;
/.
	case $rule_number: // MSRIDTEXT
		addStyleSym(Styles::Normal, 1);
		break;
./
------ Measurements Definitions

MeasurementsRubbish: AlNum
/. case $rule_number: ./
	| COLON
/. case $rule_number: ./
	| EQUAL
/. case $rule_number: ./
	| POINT
/. case $rule_number: ./
	| POINTS
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		break;
./
	| MeasurementsRubbish AlNum
/. case $rule_number: ./
	| MeasurementsRubbish COLON
/. case $rule_number: ./
	| MeasurementsRubbish EQUAL
/. case $rule_number: ./
	| MeasurementsRubbish POINT
/. case $rule_number: ./
	| MeasurementsRubbish POINTS;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		break;
./

MeasurementsValuesBase: Number Number Number Number;
/.
	case $rule_number:
		addStyleSym(Styles::PointCoord, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::PointCoord, 3);
		addStyleSym(Styles::Normal, 4);
		break;
./

Measurements: MeasurementsLists; -- it should be MeasurementsStart MeasurementsLists;
/.
	case $rule_number:
		endFolding();
		break;
./
MeasurementsStart: MeasurementsStartToken EOL;
MeasurementsStartToken: MEASURES_START WORD ASTERISKS;
/.
	case $rule_number: // MEASURES
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		contextChange(Context::MEASURES);
		startFolding();
		break;
./
MeasurementsLists: MeasurementsList
	| MeasurementsLists MeasurementsList;
MeasurementsList: MsrCamd
/. case $rule_number: ./
	| MsrEdm
/. case $rule_number: ./
	| MsrLevel
/. case $rule_number: ./
	| MsrPolar
/. case $rule_number: ./
	| MsrScale
/. case $rule_number: ./
	| MsrHlsr
/. case $rule_number: ./
	| MsrWpsr
/. case $rule_number: ./
	| MsrNoType;
/.
	case $rule_number:
		endFolding();
		_curTmp.clear();
		_curHeaderPoint.clear();
		break;
./

-- CAM
MsrCamd: MsrCam;
MsrCam: MsrCamHeader MsrCamMeasures;
MsrCamHeader: MsrCamHeaderStart EOL MsrCamHeaderSecondLine EOL;
MsrCamHeaderStart: CAM WORD COLON INSTRNAMEDEF;
/.
	case $rule_number: // CAM
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::Normal, 3);
		startFolding();
		break;
./
MsrCamHeaderSecondLine: WORD POINTNAMEDEF;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		_curHeaderPoint = toTrimmedQString(sym(2));
		break;
./
MsrCamMeasures: MsrCamMeasureList
	| MsrCamMeasures MsrCamMeasureList;
MsrCamMeasureList: MsrCamMeasureListUvec
/. case $rule_number: ./
	| MsrCamMeasureListUvd;
/.
	case $rule_number:
		endFolding();
		break;
./

-- EDM
MsrEdm: MsrEdmHeader MsrEdmMeasures;
MsrEdmHeader: MsrEdmHeaderStart EOL MsrEdmHeaderSecondLine EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL;
MsrEdmHeaderStart: EDM WORD COLON INSTRNAMEDEF;
/.
	case $rule_number: // EDM
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::Normal, 3);
		startFolding();
		break;
./
MsrEdmHeaderSecondLine: WORD WORD POINTNAMEDEF MeasurementsRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		_curHeaderPoint = toTrimmedQString(sym(3));
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DSPT", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "DSPT", _curHeaderPoint});
		}
		break;
./
MsrEdmMeasures: MsrEdmMeasure EOL
	| MsrEdmMeasures MsrEdmMeasure EOL;

MsrEdmMeasure: MsrDsptMeasure;
MsrDsptMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingConstSConst TGTNAMEDEF MsrValuesRemainingHtrgt MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingConstSConst TGTNAMEDEF MsrValuesRemainingHtrgt MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("DSPT", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

-- LEVEL
MsrLevel: MsrLevelHeader MsrLevelMeasures;
MsrLevelHeader: MsrLevelHeaderStart EOL MsrLevelHeaderSecondLine EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL;
MsrLevelHeaderStart: LEVEL WORD COLON INSTRNAMEDEF;
/.
	case $rule_number: // DLEV
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::Normal, 3);
		startFolding();
		break;
./
MsrLevelHeaderSecondLine: WORD WORD POINTNAMEDEF MeasurementsRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		_curHeaderPoint = toTrimmedQString(sym(3));
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DLEV", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "DLEV", _curHeaderPoint});
		}
		break;
./
MsrLevelMeasures: MsrLevelMeasure EOL
	| MsrLevelMeasures MsrLevelMeasure EOL;
MsrLevelMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingConstSConst MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingConstSConst MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("DLEV", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
			{
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
				// Depending on DHOR provide different behavior
				if (_inputData.measures.at(msrid).representation.contains("DHOR"))
				{
					checkNumberInRange(14, 0, 0, TextMarker::INFO, Styles::Normal, Styles::ValueImportant);
					checkNumberInRange(9, -_threshMSigma, _threshMSigma, TextMarker::WARNING);
				}
				else
					checkNumberInRange(9, 0, 0, TextMarker::INFO, Styles::Normal, Styles::ValueImportant);
			}
		}
		break;
./

-- POLAR
MsrPolar: MsrOrie
	| MsrTstn;

MsrOrie: MsrOrieHeader MsrOrieMeasures;
MsrOrieHeader: MsrOrieHeaderStart EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL;
MsrOrieHeaderStart: PLRORIE WORD WORD WORD;
/.
	case $rule_number: // ORIE
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		addStyleSym(Styles::MeasureType, 4);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ORIE", "");
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "ORIE", ""});
		}
		break;
./
MsrOrieMeasures: MsrOrieMeasure EOL
	| MsrOrieMeasures MsrOrieMeasure EOL;
MsrOrieMeasure: POINTNAMEDEF POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma TGTNAMEDEF MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma TGTNAMEDEF MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		// TGTNAMEDEF cannot have indicator since ORIE in the results does not display the instrument name that we can refer to
		if (_lexerMode)
		{
			_curTmp = toTrimmedQString(sym(1));
			QString msrid = setMeasure("ORIE", toTrimmedQString(sym(2)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 3, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrTstn: MsrTstnHeader MsrTstnMeasures;
MsrTstnHeader: MsrTstnHeaderStart EOL MsrTstnHeaderSecondLine EOL MeasurementsRubbish EOL;
MsrTstnHeaderStart: POLAIRE WORD COLON INSTRNAMEDEF;
/.
	case $rule_number: // POLAR
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::Normal, 3);
		startFolding();
		break;
./
MsrTstnHeaderSecondLine: WORD POINTNAMEDEF MeasurementsRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		_curHeaderPoint = toTrimmedQString(sym(2));
		break;
./
MsrTstnMeasures: MsrTstnMeasureList
	| MsrTstnMeasures MsrTstnMeasureList;
MsrTstnMeasureList: MsrTstnMeasureListAngle
/. case $rule_number: ./
	| MsrTstnMeasureListEcdir
/. case $rule_number: ./
	| MsrTstnMeasureListEcth
/. case $rule_number: ./
	| MsrTstnMeasureListDhor
/. case $rule_number: ./
	| MsrTstnMeasureListDist
/. case $rule_number: ./
	| MsrTstnMeasureListZend
/. case $rule_number: ./
	| MsrTstnMeasureListPlr3d;
/.
	case $rule_number:
		endFolding();
		break;
./

---- Measurements

-- POLAR
MsrTstnMeasureListAngle: MsrTstnMeasureAngleHeader MsrTstnMeasureAngleMeasures;
MsrTstnMeasureAngleHeader: MsrTstnMeasureAngleHeaderStart EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrTstnMeasureAngleHeaderStart: TSTNANGL WORD MeasurementsRubbish;
/.
	case $rule_number: // TSTNANGL
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ANGL", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNANGL", _curHeaderPoint});
		}
		break;
./
MsrTstnMeasureAngleMeasures: MsrTstnMeasureAngleMeasure EOL
	| MsrTstnMeasureAngleMeasures MsrTstnMeasureAngleMeasure EOL;
MsrTstnMeasureAngleMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingNumber MsrValuesRemainingSigma TGTNAMEDEF MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingNumber MsrValuesRemainingSigma TGTNAMEDEF MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNANGL", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrTstnMeasureListEcdir: MsrTstnMeasureEcdirHeader MsrTstnMeasureEcdirMeasures;
MsrTstnMeasureEcdirHeader: MsrTstnMeasureEcdirHeaderStart EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrTstnMeasureEcdirHeaderStart: TSTNECDIR WORD MeasurementsRubbish;
/.
	case $rule_number: // TSTNECDIR
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ECDIR", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNECDIR", _curHeaderPoint});
		}
		break;
./
MsrTstnMeasureEcdirMeasures: MsrTstnMeasureEcdirMeasure EOL
	| MsrTstnMeasureEcdirMeasures MsrTstnMeasureEcdirMeasure EOL;
MsrTstnMeasureEcdirMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers INSTRNAME MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers INSTRNAME MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number: // MsrTstnMeasureEcdirMeasure
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNECDIR", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrTstnMeasureListEcth: MsrTstnMeasureEcthHeader MsrTstnMeasureEcthMeasures;
MsrTstnMeasureEcthHeader: MsrTstnMeasureEcthHeaderStart EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrTstnMeasureEcthHeaderStart: TSTNECTH WORD MeasurementsRubbish;
/.
	case $rule_number: // TSTNECTH
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ECTH", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNECTH", _curHeaderPoint});
		}
		break;
./
MsrTstnMeasureEcthMeasures: MsrTstnMeasureEcthMeasure EOL
	| MsrTstnMeasureEcthMeasures MsrTstnMeasureEcthMeasure EOL;
MsrTstnMeasureEcthMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumber INSTRNAME MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumber INSTRNAME MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number: // MsrTstnMeasureEcthMeasure
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNECTH", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrTstnMeasureListDhor: MsrTstnMeasureDhorHeader MsrTstnMeasureDhorMeasures;
MsrTstnMeasureDhorHeader: MsrTstnMeasureDhorHeaderStart EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrTstnMeasureDhorHeaderStart: TSTNDHOR WORD MeasurementsRubbish;
/.
	case $rule_number: // TSTNDHOR
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DHOR", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNDHOR", _curHeaderPoint});
		}
		break;
./
MsrTstnMeasureDhorMeasures: MsrTstnMeasureDhorMeasure EOL
	| MsrTstnMeasureDhorMeasures MsrTstnMeasureDhorMeasure EOL;
MsrTstnMeasureDhorMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingConstSConst TGTNAMEDEF MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingConstSConst TGTNAMEDEF MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number: // MsrTstnMeasureDhorMeasure
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNDHOR", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrTstnMeasureListZend: MsrTstnMeasureZendHeader MsrTstnMeasureZendMeasures;
MsrTstnMeasureZendHeader: MsrTstnMeasureZendHeaderStart EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrTstnMeasureZendHeaderStart: TSTNZEND WORD MeasurementsRubbish;
/.
	case $rule_number: // TSTNZEND
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("ZEND", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNZEND", _curHeaderPoint});
		}
		break;
./
MsrTstnMeasureZendMeasures: MsrTstnMeasureZendMeasure EOL
	| MsrTstnMeasureZendMeasures MsrTstnMeasureZendMeasure EOL;
MsrTstnMeasureZendMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingNumber MsrValuesRemainingSigma TGTNAMEDEF MsrValuesRemainingNumbers
/. case $rule_number: ./
		| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingNumber MsrValuesRemainingSigma TGTNAMEDEF MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNZEND", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
			if (contains(_resData.measures, msrid))
				_resData.measures.at(msrid).others.append(";H_TGT:" + toTrimmedQString(sym(6)));
		}
		break;
./

MsrTstnMeasureListDist: MsrTstnMeasureDistHeader MsrTstnMeasureDistMeasures;
MsrTstnMeasureDistHeader: MsrTstnMeasureDistHeaderStart EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrTstnMeasureDistHeaderStart: TSTNDIST WORD MeasurementsRubbish;
/.
	case $rule_number: // TSTNDIST
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DIST", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNDIST", _curHeaderPoint});
		}
		break;
./
MsrTstnMeasureDistMeasures: MsrTstnMeasureDistMeasure EOL
	| MsrTstnMeasureDistMeasures MsrTstnMeasureDistMeasure EOL;
MsrTstnMeasureDistMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingConstSConst TGTNAMEDEF MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingConstSConst TGTNAMEDEF MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNDIST", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
			if (contains(_resData.measures, msrid))
				_resData.measures.at(msrid).others.append(";H_TGT:" + toTrimmedQString(sym(7)));
			QString zendmsrid = msrid.replace("TSTNDIST", "TSTNZEND");
			if (contains(_resData.measures, zendmsrid))
			{
				const LGCMeasures::Value &zend = _resData.measures[zendmsrid];
				double H_TGT = zend.others.mid(zend.others.indexOf("H_TGT:") + QString("H_TGT:").length()).toDouble();
				checkNumberInRange(7, H_TGT, H_TGT, TextMarker::WARNING, Styles::Normal, Styles::ValueError, tr(R"""(<p style="color: red;">The values of height for ZEND and DIST should match.</p>)"""));
			}
		}
		break;
./

MsrTstnMeasureListPlr3d: MsrTstnMeasureListPlr3dHeader MsrTstnMeasureListPlr3dMeasures;
MsrTstnMeasureListPlr3dHeader: MsrTstnMeasureListPlr3dHeaderStart EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL;
MsrTstnMeasureListPlr3dHeaderStart: PLR3D MeasurementsRubbish;
/.
	case $rule_number: // TSTNPLR3D
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("PLR3D", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "TSTNPLR3D", _curHeaderPoint});
		}
		break;
./
MsrTstnMeasureListPlr3dMeasures: MsrTstnMeasureListPlr3dMeasure EOL
	| MsrTstnMeasureListPlr3dMeasures MsrTstnMeasureListPlr3dMeasure EOL;
MsrTstnMeasureListPlr3dMeasure: POINTNAMEDEF WORD
	MeasurementsValuesBase WORD
	MeasurementsValuesBase WORD
	MeasurementsValuesBase WORD
	MeasurementsRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::Normal, 8);

		if (_lexerMode)
		{
			QString msrid = setMeasure("TSTNPLR3D", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
			{
				addIndicationSym(TextIndicator::EXTERNAL, 3, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
				addIndicationSym(TextIndicator::EXTERNAL, 5, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
				addIndicationSym(TextIndicator::EXTERNAL, 7, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
			}
			//QString msrid = setMeasure("TSTNPLR3D/" + toTrimmedQString(sym(1)), 5);
			//QString msrid = setMeasure("TSTNPLR3D/" + toTrimmedQString(sym(1)), 7);
		}
		break;
./

-- CAMD
MsrCamMeasureListUvec: MsrCamMeasureUvecHeader MsrCamMeasureUvecMeasures;
MsrCamMeasureUvecHeader: MsrCamMeasureUvecHeaderStart EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrCamMeasureUvecHeaderStart: CAMUVEC WORD MeasurementsRubbish;
/.
	case $rule_number: // CAMUVEC
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("UVEC", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "CAMUVEC", _curHeaderPoint});
		}
		break;
./
MsrCamMeasureUvecMeasures: MsrCamMeasureUvecMeasure EOL
	| MsrCamMeasureUvecMeasures MsrCamMeasureUvecMeasure EOL;
MsrCamMeasureUvecMeasure: TGTNAMEDEF POINTNAMEDEF MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumber MsrValuesRemainingNumber
	MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumbers
/. case $rule_number: ./
	| TGTNAMEDEF POINTNAMEDEF MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumber MsrValuesRemainingNumber
		MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("CAMUVEC", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrCamMeasureListUvd: MsrCamMeasureUvdHeader MsrCamMeasureUvdMeasures;
MsrCamMeasureUvdHeader: MsrCamMeasureUvdHeaderStart EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrCamMeasureUvdHeaderStart: CAMUVD WORD WORD WORD MeasurementsRubbish;
/.
	case $rule_number: // CAMUVD
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		addStyleSym(Styles::MeasureType, 4);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("UVD", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, _curTmp, "", "CAMUVD", _curHeaderPoint});
		}
		break;
./
MsrCamMeasureUvdMeasures: MsrCamMeasureUvdMeasure EOL
	| MsrCamMeasureUvdMeasures MsrCamMeasureUvdMeasure EOL;
MsrCamMeasureUvdMeasure: TGTNAMEDEF POINTNAMEDEF MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumber MsrValuesRemainingNumber
	MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumbers
/. case $rule_number: ./
	| TGTNAMEDEF POINTNAMEDEF MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumber MsrValuesRemainingNumber
		MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("CAMUVD", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./


-- SCALE
MsrScale: MsrEcho
	| MsrEcsp
	| MsrEcve;

MsrEcho: MsrEchoHeader MsrEchoMeasures;
MsrEchoHeader: MsrEchoHeaderStart EOL MsrEchoHeaderSecondLine EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL
	MeasurementsRubbish EOL;
MsrEchoHeaderStart: ECHO;
/.
	case $rule_number: // ECHO
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;
./
MsrEchoHeaderSecondLine: WORD WORD POINTNAMEDEF MeasurementsRubbish;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		if (_lexerMode)
		{
			_curHeaderPoint = toTrimmedQString(sym(3));
			QString msrid = findSummaryMeasureKey("ECHO", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "ECHO", _curHeaderPoint});
		}
		break;
./
MsrEchoMeasures: MsrEchoMeasure EOL
	| MsrEchoMeasures MsrEchoMeasure EOL;
MsrEchoMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma INSTRNAME MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma INSTRNAME MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECHO", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrEcsp: MsrEcspHeader MsrEcspMeasures;
MsrEcspHeader: MsrEcspHeaderStart EOL MsrEcspHeaderSecondLine EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrEcspHeaderStart: ECSP WORD;
/.
	case $rule_number: // ECSP
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		break;
./
MsrEcspHeaderSecondLine: WORD POINTNAMEDEF WORD POINTNAMEDEF;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 3);
		// if (_lexerMode) { } // measure for ECHOLINE should be added here to link the summary with it but this name is not repeated
		// either this is TODO for LGC to place it somewhere or LGC-plugin will need to track it itself
		break;
./
MsrEcspMeasures: MsrEcspMeasure EOL
	| MsrEcspMeasures MsrEcspMeasure EOL;
MsrEcspMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma INSTRNAME MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma INSTRNAME MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECSP", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrEcve: MsrEcveHeader MsrEcveMeasures;
MsrEcveHeader: MsrEcveHeaderStart EOL MsrEcveHeaderSecondLine EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrEcveHeaderStart: ECVE;
/.
	case $rule_number: // ECVE
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		break;
./
MsrEcveHeaderSecondLine: POINT WORD WORD WORD POINTNAMEDEF WORD Number WORD Number WORD Number;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 6);
		addStyleSym(Styles::ValueImportant, 7);
		addStyleSym(Styles::Normal, 8);
		addStyleSym(Styles::ValueImportant, 9);
		addStyleSym(Styles::Normal, 10);
		addStyleSym(Styles::ValueImportant, 11);
		// if (_lexerMode) { } // measure for ECVELINE0 should be added here to link the summary with it but this name is not repeated
		// either this is TODO for LGC to place it somewhere or LGC-plugin will need to track it itself
		break;
./
MsrEcveMeasures: MsrEcveMeasure EOL
	| MsrEcveMeasures MsrEcveMeasure EOL;
MsrEcveMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma INSTRNAME MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma INSTRNAME MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECVE", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

-- INCL
MsrIncl: MsrIncly;

MsrIncly: MsrInclyHeader MsrInclyMeasures;
MsrInclyHeader: MsrInclyToken EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrInclyToken: INCLY;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("INCLY", _curTmp);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "INCLY", ""});
		}
		break;
./
MsrInclyMeasures: MsrInclyMeasure EOL
	| MsrInclyMeasures MsrInclyMeasure EOL;
MsrInclyMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma INSTRNAME MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma INSTRNAME MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("INCLY", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

-- Hlsr
MsrHlsr: MsrEcws;

MsrEcws: MsrEcwsHeader MsrEcwsMeasures;
MsrEcwsHeader: MsrEcwsToken EOL MsrEcwsHeaderSecondLine EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrEcwsHeaderSecondLine: WORD WORD WORD WORD WORD COLON POINTNAMEDEF;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);
		addStyleSym(Styles::Normal, 5);
		addStyleSym(Styles::Normal, 6);
		if (_lexerMode)
		{
			_curHeaderPoint = toTrimmedQString(sym(7));
			QString msrid = findSummaryMeasureKey("ECWS", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "ECWS", _curHeaderPoint});
		}

		break;
./
MsrEcwsToken: ECWS;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		break;
./
MsrEcwsMeasures: MsrEcwsMeasure EOL
	| MsrEcwsMeasures MsrEcwsMeasure EOL;
MsrEcwsMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers INSTRNAME MSRIDTEXT
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers INSTRNAME
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers INSTRNAME MsrValuesRemainingNumber
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECWS", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./
-- Wpsr
MsrWpsr: MsrEcwi;

MsrEcwi: MsrEcwiHeader MsrEcwiMeasures;
MsrEcwiHeader: MsrEcwiToken EOL MsrEcwiHeaderSecondLine EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrEcwiHeaderSecondLine: WORD WORD WORD POINTNAMEDEF;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		if (_lexerMode)
		{
			_curHeaderPoint = toTrimmedQString(sym(4));
			QString msrid = findSummaryMeasureKey("ECWI", _curHeaderPoint);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "ECWI", _curHeaderPoint});
		}

		break;
./
MsrEcwiToken: ECWI;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		break;
./
MsrEcwiMeasures: MsrEcwiMeasure EOL
	| MsrEcwiMeasures MsrEcwiMeasure EOL;
MsrEcwiMeasure: POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers INSTRNAME
/. case $rule_number: ./
	| POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers INSTRNAME MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("ECWI", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

-- NOTYPE
MsrNoType: MsrDver
	| MsrObsxyz
	| MsrRadi;

MsrDver: MsrDverHeader MsrDverMeasures;
MsrDverHeader: MsrDverToken EOL MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrDverToken: DVER;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("DVER", "ROOT");
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "DVER", ""});
		}
		break;
./
MsrDverMeasures: MsrDverMeasure EOL
	| MsrDverMeasures MsrDverMeasure EOL;
MsrDverMeasure: POINTNAMEDEF POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF POINTNAMEDEF MeasurementsValuesBase MsrValuesRemainingSigma MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		if (_lexerMode)
		{
			QString msrid = setMeasure("DVER", toTrimmedQString(sym(1)) + toTrimmedQString(sym(2)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 3, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

MsrObsxyz: MsrObsxyzHeader MsrObsxyzMeasures;
MsrObsxyzHeader: MsrObsxyzToken MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrObsxyzToken: CONTRAINTES3D WORD WORD WORD WORD;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		addStyleSym(Styles::MeasureType, 3);
		addStyleSym(Styles::MeasureType, 4);
		addStyleSym(Styles::MeasureType, 5);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("OBSXYZ", _curTmp.isEmpty() ? "ROOT" : _curTmp);
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "OBSXYZ", ""});
		}
		break;
./
MsrObsxyzMeasures: MsrObsxyzMeasure EOL
	| MsrObsxyzMeasures MsrObsxyzMeasure EOL;
MsrObsxyzMeasure: POINTNAMEDEF WORD MsrValuesRemainingNumber MsrValuesRemainingNumber MsrValuesRemainingSigma MSRIDTEXT
/. case $rule_number: ./
	| POINTNAMEDEF WORD MsrValuesRemainingNumber MsrValuesRemainingNumber MsrValuesRemainingSigma MsrValuesRemainingNumber
/. case $rule_number: ./
	| POINTNAMEDEF WORD MsrValuesRemainingNumber MsrValuesRemainingNumber MsrValuesRemainingSigma;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);

		if (_lexerMode)
		{
			QString msrid = setMeasure("OBSXYZ", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 3, _inputData.measures.at(msrid).position);
		}
		break;
./

MsrRadi: MsrRadiHeader MsrRadiMeasures;
MsrRadiHeader: MsrRadiToken EOL MsrRadiTokenBis MeasurementsRubbish EOL MeasurementsRubbish EOL MeasurementsRubbish EOL;
MsrRadiToken: RADIAL WORD;
/.
	case $rule_number:
		addStyleSym(Styles::MeasureType, 1);
		addStyleSym(Styles::MeasureType, 2);
		startFolding();
		if (_lexerMode)
		{
			QString msrid = findSummaryMeasureKey("RADI", "ROOT");
			_resData.instruments.emplace(msrid, LGCMeasures::Value{sym(1).position(), msrid, "", "", "RADI", ""});
		}
		break;
./
MsrRadiTokenBis: RADIAL WORD;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 1);
		addStyleSym(Styles::Normal, 2);
		break;
./
MsrRadiMeasures: MsrRadiMeasure EOL
	| MsrRadiMeasures MsrRadiMeasure EOL;
MsrRadiMeasure: POINTNAMEDEF Number Number Number MsrValuesRemainingSigma MsrValuesRemainingNumbers
/. case $rule_number: ./
	| POINTNAMEDEF Number Number Number MsrValuesRemainingSigma MsrValuesRemainingNumbers MSRIDTEXT;
/.
	case $rule_number:
		addStyleSym(Styles::Normal, 2);
		addStyleSym(Styles::Normal, 3);
		addStyleSym(Styles::Normal, 4);

		if (_lexerMode)
		{
			QString msrid = setMeasure("RADI", toTrimmedQString(sym(1)));
			if (contains(_inputData.measures, msrid))
				addIndicationSym(TextIndicator::EXTERNAL, 2, LGCMeasures::encodeIndicator(msrid, LGCMeasures::LGCMeasuresEnum::measures));
		}
		break;
./

---- Erel

Erel: ErelStart ErelHeader ErelPoints;
/.
	case $rule_number: // Erel
		endFolding();
		break;
./

ErelStart: ErelStartToken EOL ErelStartSecondLine EOL;
ErelStartToken: EREL_START WORD;
/.
	case $rule_number:
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		startFolding();
		break;
./
ErelStartSecondLine: ASTERISKS;
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./

ErelHeader: MeasurementsRubbish EOL MeasurementsRubbish EOL;

ErelPoints: ErelPoint EOL
	| ErelPoints ErelPoint EOL;
ErelPoint: POINTNAMEDEF POINTNAMEDEF FRAMENAME MeasurementsRubbish;

---- ErelFrame

ErelFrame: ErelFrameStart ErelFrameEntries;
/.
	case $rule_number: // ErelFrame
		endFolding();
		break;
./

ErelFrameStart: ErelFrameStartToken EOL ErelFrameSecondLine EOL;
ErelFrameStartToken: EREL_START WORD WORD; -- Last Word is FRAME
/.
	case $rule_number:
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		startFolding();
		break;
./
ErelFrameSecondLine: ASTERISKS;
/.
	case $rule_number:
		addStyleSym(Styles::Comment, 1);
		break;
./

ErelFrameEntries: ErelFrameEntry ErelFrameEntries
	| ErelFrameEntry;
ErelFrameEntry: ErelFrameEntryHeader Frame;
ErelFrameEntryHeader: WORD WORD COLON ErelFrameTransformation EOL;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::Normal);
		break;
./
ErelFrameTransformation: WORD;

-- FRAME

---- FRAME COMPONENTS

FrameDef: FrameDescription
	| FrameDescription FrameHeader FrameData;
FrameDescription: FRAMETOKEN FRAMENAME FrameID EOL
/. case $rule_number: ./
	| FRAMETOKEN ErelFrameTransformation EOL
/. case $rule_number: ./
	| FRAMETOKEN FRAMENAME FrameID FrameDescriptionSlave EOL;
/.
	case $rule_number:
		_curTmp = toTrimmedQString(sym(2));
		break;
./
FrameDescriptionSlave: WORD COLON FrameRubbish;
FrameID: WORD;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::ValueImportant);
		
		_curTmpFrameLevelNext = sym(1).count('_');
		if(!_curTmpFrameLevelNext) // skip ROOT
			break; 
		else if(_curTmpFrameLevelNext < _curTmpFrameLevel) // Move from nested to outer
		{
			for (int i = 0; i < _curTmpFrameLevel - _curTmpFrameLevelNext + 1; i++)
				endFolding();
		}
		else if(_curTmpFrameLevelNext == _curTmpFrameLevel) // Move from same to same
			endFolding();
		_curTmpFrameLevel = _curTmpFrameLevelNext;
			
		startFolding();
		break;
./

FrameRubbish: FrameRubbish AlNum 
	| AlNum;
FrameHeader: FrameHeaderStartToken FrameRubbish EOL;
FrameHeaderStartToken: FRAME_PARAMETER;
/.
	case $rule_number:
		addStyle(_currentLine.length(), Styles::Normal);
		break;
./
FrameData: FrameData FrameRubbish EOL
	| FrameRubbish EOL;
	
FrameTransformations: FrameTransformations FrameTransformation
	| FrameTransformation;
FrameTransformation: FrameTransformationToken FrameTransformationRubbish EOL;
FrameTransformationRubbish: FrameTransformationRubbish AlNum 
	| FrameTransformationRubbish COLON
	| AlNum;	
	
---- FRAME MEASURES

FrameMeasures: FrameMeasuresStart -- If there are no measures, this keyword should not appear in LGC2
	| FrameMeasuresStart FrameMeasuresLists;
FrameMeasuresStart: FrameMeasuresStartToken EOL;
FrameMeasuresStartToken: MEASURES_START WORD ASTERISKS;
/.
	case $rule_number: // FRAME MEASURES
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		break;
./

------ POLAR//TSTN ANGL ZEND DIST

FrameMsrPolar: MsrTstnHeader FrameMsrTstnMeasures;
FrameMsrTstnMeasures: FrameMsrTstnMeasureList
	| FrameMsrTstnMeasures FrameMsrTstnMeasureList;
FrameMsrTstnMeasureList: MsrTstnMeasureListAngle
/. case $rule_number: ./
	| MsrTstnMeasureListDist
/. case $rule_number: ./
	| MsrTstnMeasureListZend;
/.
	case $rule_number:
		endFolding();
		break;
./

------ NOTYPE//OBSXYZ
FrameMsrNoType: MsrObsxyz;

------ CAM// UVEC UVD
FrameMsrCamd: MsrCamd;

------ INCL// INCLY
FrameMsrIncl: MsrIncl;

------ Lists

FrameMeasuresLists: FrameMeasuresList
	| FrameMeasuresList FrameMeasuresLists;
FrameMeasuresList: FrameMsrNoType
	/. case $rule_number: ./
	| FrameMsrCamd
	/. case $rule_number: ./
	| FrameMsrIncl
	/. case $rule_number: ./
	| FrameMsrPolar;
/.
	case $rule_number:
		endFolding();
		_curTmp.clear();
		_curHeaderPoint.clear();
		break;
./

---- FRAME POINTS
FramePoints: FramPointsLists;
FramPointsLists: FramPointsLists FramPointsList
	| FramPointsList;
FramPointsList: FramePointType EOL StatisticsSFPToken StatisticsRubbish EOL StatisticsRubbish EOL StatisticsPointsDef;
/.
	case $rule_number:
		if (!_contexts.empty())
			_contexts.pop_back();
		endFolding();
		break;
./
FramePointType: StatisticsPointTypeCala
	| StatisticsPointTypeXYZ;

---- FRAME DEFINITION 

Frame: FrameDef FrameContents;
	
FrameContents: FrameMeasures
	| FrameTransformations FrameMeasures
	| FrameTransformations FramePoints FrameMeasures 
	| FrameTransformations
	| FrameTransformations FramePoints
	| FramePoints
	| FramePoints FrameMeasures;

-- FRAMES

Frames: Frames Frame
	| Frame;

---- End

End: EndToken EOL;
EndToken: END WORD WORD WORD ASTERISKS;
/.
	case $rule_number: // END
		addStyleSym(Styles::Section, 1);
		addStyleSym(Styles::Section, 2);
		addStyleSym(Styles::Section, 3);
		addStyleSym(Styles::Section, 4);
		addStyleSym(Styles::Section, 5);
		for (int i = 0; i < (_curTmpFrameLevel); i++)
			endFolding();
		break;
./

----------------------------------------------------------- ENDRULES

/.
	} // of the switch
}

int LGCOutputResLexer::nextToken(QStringRef value)
{
	static const QRegularExpression numericrgx = ([]() -> QRegularExpression {
		QRegularExpression rgx(R"""(^-?[[:digit:]]*\.?[[:digit:]]+$)""");
		rgx.optimize();
		return rgx;
	})();

	QStringRef tval = value.trimmed();

	if (!tval.isEmpty())
	{
		// sections
		if (!_contexts.empty())
		{
			if (_contexts.back() == Context::HEADER && value.position() == _currentLine.position() && _currentLine.startsWith(LGCOutputResLexer::spell[LGCOutputResLexer::SUMMARY_START]))
				return LGCOutputResLexer::SUMMARY_START;
			if (_contexts.back() == Context::SUMMARY && value.position() == _currentLine.position() && _currentLine.startsWith(LGCOutputResLexer::spell[LGCOutputResLexer::STATISTICS_START]))
				return LGCOutputResLexer::STATISTICS_START;
		}
		// keywords
		if (tval == LGCOutputResLexer::spell[LGCOutputResLexer::IND])
			return LGCOutputResLexer::IND;
		if (value.position() == _currentLine.position() && (_contexts.empty() || _contexts.back() > Context::SUMMARY) || !_inlineContexts.empty())
		{
			QString tmptok;
			for (int i = 0; i < LGCOutputResLexer::TERMINAL_COUNT; i++)
			{
				if (tval == LGCOutputResLexer::spell[i])
					return i;
				tmptok = LGCOutputResLexer::spell[i];
				if (tmptok.contains(' ') && _currentLine.trimmed().startsWith(LGCOutputResLexer::spell[i]))
					return i;
			}
		}
		// special characters
		if (std::all_of (std::cbegin(tval), std::cend(tval), [](const auto &ch) -> bool { return ch == '*'; }))
			return LGCOutputResLexer::ASTERISKS;
		if (tval.size() == 1)
		{
			switch (tval[0].unicode())
			{
			case ':':
				return LGCOutputResLexer::COLON;
			case '=':
				return LGCOutputResLexer::EQUAL;
			}
		}
		// numbers
		if (numericrgx.match(tval).hasMatch())
		{
			bool ok;
			tval.toInt(&ok);
			if (ok)
				return LGCOutputResLexer::INTEGER;
			tval.toDouble(&ok);
			if (ok)
				return LGCOutputResLexer::DECIMAL;
		}
		return LGCOutputResLexer::WORD;
	}

	return LGCOutputResLexer::UNKNOWN;
}
./
